#!/bin/bash

. ../cfg/general_cfg.sh

#smanager (sends to all connected)
#rmanager or or rmanager-round-robin (sends to one of several connected round-robin way)
#rmanager-rnd (sends to one of random client)
MANAGER_MODE="rmanager-rnd"

#Valgring profiling: 0 - not used, 1 - used. If valgrind profiling used, operation time of any kind action, command, request and so on grow and can be twice or more longer.
USE_VALGRIND=0

#Local host host name
HOST="localhost"
#Data nodes host name
REPLICAS=( "localhost" )

#Management data nodes instances ports
#REPLICAS_MANAGE_ADMIN_PORTS=( 5740 5741 )
#REPLICAS_MANAGE_ADMIN_PORTS=( 5740 5741 5742 )

#Searchers data nodes instances ports
#REPLICAS_POOL_ADMIN_PORTS=( 5730 )
#REPLICAS_POOL_ADMIN_PORTS=( 5730 5731 )
#REPLICAS_POOL_ADMIN_PORTS=( 5730 5731 5732 )
REPLICAS_POOL_ADMIN_PORTS=( 5730 5731 5732 5733 )
#REPLICAS_POOL_ADMIN_PORTS=( 5730 5731 5732 5733 5734 5735 5736 5737 5738 5739 )

#Router host name
ROUTER="$HOST"
#Router ports
ROUTER_SERVER_PORT="5757"
ROUTER_ADMIN_PORT="5746"
ROUTER_CLIENT_PORT="5756"

#Manager (shard or replica) host and ports
MANAGER="213.239.218.68"
SHARD_MANAGER_ADMIN_PORT="5749"
SHARD_MANAGER_SERVER_PORT="5758"

#Binary executable name
NODE_BIN_NAME="hce-node"

BIG_TIMEOUT=20000
SMALL_TIMEOUT=5000
SEARCH_SPHINX_TIMEOUT="2000"

DRCE_DATA_DIR1="c112_localhost_drce_ft01"
DRCE_DATA_DIR2="c112_localhost_drce_ft02"
DRCE_DATA_DIR_ASYNC="c112_localhost_drce_ft_async"
DRCE_DATA_DIR_SUBTASKS="c112_localhost_drce_ft_subtasks"

NODE_APP_LOG_PREFIX="r0-2h"

#Accumulate list of replica admin ports in the csv string
REPLICA_ADMIN_PORTS_CSV=" "
for PORT in "${REPLICAS_MANAGE_ADMIN_PORTS[@]}"
  do
    REPLICA_ADMIN_PORTS_CSV="$REPLICA_ADMIN_PORTS_CSV$PORT,"
  done
for PORT in "${REPLICAS_POOL_ADMIN_PORTS[@]}"
  do
    REPLICA_ADMIN_PORTS_CSV="$REPLICA_ADMIN_PORTS_CSV$PORT,"
  done

if [ "$REPLICA_ADMIN_PORTS_CSV" != " " ]; then
#  REPLICA_ADMIN_PORTS_CSV=${REPLICA_ADMIN_PORTS_CSV:1:-1}
   REPLICA_ADMIN_PORTS_CSV="${REPLICA_ADMIN_PORTS_CSV:1:${#REPLICA_ADMIN_PORTS_CSV}-2}"
fi

INI_FILE_POOL="node_pool_r"
