#!/bin/bash

. ../cfg/current_cfg.sh

REQUESTS=1
LOG_LEVEL=4
TASK_ID=33334
#18446744073

if [ "$1" = "" ]; then
  TEST_NUMBER="00"
else
  TEST_NUMBER="$1"
fi

if [ "$2" = "" ]; then
  TASK_ID=33334
else
  TASK_ID="$2"
fi

DRCE_TEST_JSON_FILE="$DATA_DIR$DRCE_DATA_DIR_ASYNC/c112_localhost_drce_json$TEST_NUMBER.txt"
LOG_FILE="$LOG_DIR$0.$2.$NODE_APP_LOG_PREFIX.log"

#echo "New task request:" >> $LOG_FILE
#echo $BIN_DIR$DRCE_COMMAND --request=SET --host=$ROUTER --port=$ROUTER_CLIENT_PORT --n=$REQUESTS --t=$SMALL_TIMEOUT --l=$LOG_LEVEL --json=$DRCE_TEST_JSON_FILE --id=$TASK_ID >> $LOG_FILE
#$BIN_DIR$DRCE_COMMAND --request=SET --host=$ROUTER --port=$ROUTER_CLIENT_PORT --n=$REQUESTS --t=$SMALL_TIMEOUT --l=$LOG_LEVEL --json=$DRCE_TEST_JSON_FILE --id=$TASK_ID >> $LOG_FILE
#sleep 1
#exit

#Check each poll node for task state

for NODE_ADMIN_PORT in "${REPLICAS_POOL_ADMIN_PORTS[@]}"
  do
    DRCE_TEST_JSON_FILE="$DATA_DIR$DRCE_DATA_DIR_ASYNC/c112_localhost_drce_json_check$TEST_NUMBER.txt"
    echo "Check task state at node localhost:$NODE_ADMIN_PORT" >> $LOG_FILE
    echo $BIN_DIR$MANAGER_COMMAND --host=$HOST --port=$NODE_ADMIN_PORT --command=DRCE --request=CHECK --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE
    $BIN_DIR$MANAGER_COMMAND --host=$HOST --port=$NODE_ADMIN_PORT --command=DRCE --request=CHECK --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE

    DRCE_TEST_JSON_FILE="$DATA_DIR$DRCE_DATA_DIR_ASYNC/c112_localhost_drce_json_get$TEST_NUMBER.txt"
    echo "Get task data node localhost:$NODE_ADMIN_PORT" >> $LOG_FILE
    echo $BIN_DIR$MANAGER_COMMAND --host=localhost --port=$NODE_ADMIN_PORT --command=DRCE --request=GET --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE
    $BIN_DIR$MANAGER_COMMAND --host=localhost --port=$NODE_ADMIN_PORT --command=DRCE --request=GET --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE

#    sleep 40
#    DRCE_TEST_JSON_FILE="$DATA_DIR$DRCE_DATA_DIR_ASYNC/c112_localhost_drce_json_del$TEST_NUMBER.txt"
#    echo "Delete task at node localhost:$NODE_ADMIN_PORT" >> $LOG_FILE
#    echo $BIN_DIR$MANAGER_COMMAND --host=localhost --port=$NODE_ADMIN_PORT --command=DRCE --request=TERMINATE --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE
#    $BIN_DIR$MANAGER_COMMAND --host=localhost --port=$NODE_ADMIN_PORT --command=DRCE --request=TERMINATE --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE

    DRCE_TEST_JSON_FILE="$DATA_DIR$DRCE_DATA_DIR_ASYNC/c112_localhost_drce_json_check$TEST_NUMBER.txt"
    echo "Check task state at node localhost:$NODE_ADMIN_PORT" >> $LOG_FILE
    echo $BIN_DIR$MANAGER_COMMAND --host=$HOST --port=$NODE_ADMIN_PORT --command=DRCE --request=CHECK --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE
    $BIN_DIR$MANAGER_COMMAND --host=$HOST --port=$NODE_ADMIN_PORT --command=DRCE --request=CHECK --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE

#    sleep 32
#    DRCE_TEST_JSON_FILE="$DATA_DIR$DRCE_DATA_DIR_ASYNC/c112_localhost_drce_json_check$TEST_NUMBER.txt"
#    echo "Check task state at node localhost:$NODE_ADMIN_PORT" >> $LOG_FILE
#    echo $BIN_DIR$MANAGER_COMMAND --host=$HOST --port=$NODE_ADMIN_PORT --command=DRCE --request=CHECK --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE
#    $BIN_DIR$MANAGER_COMMAND --host=$HOST --port=$NODE_ADMIN_PORT --command=DRCE --request=CHECK --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE

    DRCE_TEST_JSON_FILE="$DATA_DIR$DRCE_DATA_DIR_ASYNC/c112_localhost_drce_json_get$TEST_NUMBER.txt"
    echo "Get task data node localhost:$NODE_ADMIN_PORT" >> $LOG_FILE
    echo $BIN_DIR$MANAGER_COMMAND --host=localhost --port=$NODE_ADMIN_PORT --command=DRCE --request=GET --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE
    $BIN_DIR$MANAGER_COMMAND --host=localhost --port=$NODE_ADMIN_PORT --command=DRCE --request=GET --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE

#    DRCE_TEST_JSON_FILE="$DATA_DIR$DRCE_DATA_DIR_ASYNC/c112_localhost_drce_json_check$TEST_NUMBER.txt"
#    echo "Check task state at node localhost:$NODE_ADMIN_PORT" >> $LOG_FILE
#    echo $BIN_DIR$MANAGER_COMMAND --host=$HOST --port=$NODE_ADMIN_PORT --command=DRCE --request=CHECK --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE
#    $BIN_DIR$MANAGER_COMMAND --host=$HOST --port=$NODE_ADMIN_PORT --command=DRCE --request=CHECK --id=$TASK_ID --json=$DRCE_TEST_JSON_FILE --timeout=$BIG_TIMEOUT --log=$LOG_LEVEL 2>&1 >> $LOG_FILE

 done
