#!/bin/bash

. ./dc_test_en_sites_cfg.sh

ITEM=1

for SITE_NAME in "${SITES_LIST[@]}"
  do
    echo "Site:$SITE_NAME" >> ../log/$0.log

    REQUEST_JSON="$DATA_DIR""url_content_""$SITE_NAME""_multi.json"
    RESULTS_JSON="../log/$0""_""$SITE_NAME"".result.json"

    echo "URLs contents with date range condition" >> ../log/$0.log 2>&1
    ../bin/dc-client.py --config=../ini/dc-client.ini --command=URL_CONTENT --file=$REQUEST_JSON > $RESULTS_JSON 2>&1

    echo "Get content #$ITEM to view tags" >> ../log/$0.log 2>&1
    cd ../bin
    ./json-field.py -f "itemsList:0:itemObject:$ITEM:processedContents:0:buffer" -b 1 < $RESULTS_JSON > $RESULTS_JSON.value
    cd ../ftests

    cd ../../php/bin
    if [ -s ../../python/log/$RESULTS_JSON.value ]; then
      echo "Convert json to xml" >> ../log/$0.log 2>&1
      ./json-field.php --field=@ --xml=1 < ../../python/log/$RESULTS_JSON.value > ../../python/log/$RESULTS_JSON.xml
    else
      echo "Content from site '$SITE_NAME' is not fetchecd!" >> ../../python/log/$0.log 2>&1
    fi
    cd ../../python/ftests

    echo "" >> ../log/$0.log 2>&1
  done
