#!/bin/bash

#USAGE:
#dc_test_integrity.sh [site_id] [all | good] [r]
# site_id - Id of the site
# all - select all URLs, good - selects URLs by Status, PDate and TagsMask conditions
# r - delete URL_CONTENT request response json from log directory

LIMIT="10000"

#Init the SITE_ID
if [ "$1" = "" ]; then
  SITE_ID="333abec8c863dd0ca69963fb0ab8b97e"
else
  SITE_ID="$1"
fi

#Init fields set type
if [ "$2" = "" ] || [ "$2" = "good" ] ; then
  FIELDS="{\"urlFetch\":{\"maxURLs\": $LIMIT,\"sitesCriterions\": {\"WHERE\": \"\`Id\`=\\\"$SITE_ID\\\"\"},\"urlsCriterions\": {\"WHERE\": \"Status=7 AND PDate>=CURDATE() AND ((TagsMask & 60) = 60)\", \"LIMIT\": $LIMIT}}}"
else
  if [ "$2" = "all" ]; then
    FIELDS="{\"urlFetch\":{\"maxURLs\": $LIMIT,\"sitesCriterions\": {\"WHERE\": \"\`Id\`=\\\"$SITE_ID\\\"\"},\"urlsCriterions\": {\"LIMIT\": $LIMIT}}}"
  else
    if [ "$2" = "goodtm" ]; then
      FIELDS="{\"urlFetch\":{\"maxURLs\": $LIMIT,\"sitesCriterions\": {\"WHERE\": \"\`Id\`=\\\"$SITE_ID\\\"\"},\"urlsCriterions\": {\"WHERE\": \"Status=7 AND ((TagsMask & 60) = 60)\", \"LIMIT\": $LIMIT}}}"
    else
      if [ "$2" = "goodpd" ]; then
        FIELDS="{\"urlFetch\":{\"maxURLs\": $LIMIT,\"sitesCriterions\": {\"WHERE\": \"\`Id\`=\\\"$SITE_ID\\\"\"},\"urlsCriterions\": {\"WHERE\": \"Status=7 AND PDate>=CURDATE()\", \"LIMIT\": $LIMIT}}}"
      else
        if [ "$2" = "goodpd" ]; then
          FIELDS="{\"urlFetch\":{\"maxURLs\": $LIMIT,\"sitesCriterions\": {\"WHERE\": \"\`Id\`=\\\"$SITE_ID\\\"\"},\"urlsCriterions\": {\"WHERE\": \"Status=7 AND PDate>=CURDATE()\", \"LIMIT\": $LIMIT}}}"
        else
          if [ "$2" = "yesterday" ]; then
            FIELDS="{\"urlFetch\":{\"maxURLs\": $LIMIT,\"sitesCriterions\": {\"WHERE\": \"\`Id\`=\\\"$SITE_ID\\\"\"},\"urlsCriterions\": {\"WHERE\": \"Status=7 AND PDate>=SUBDATE(CURDATE(),1)\", \"LIMIT\": $LIMIT}}}"
          else
            if [ "$2" = "own" ]; then
              FIELDS="{\"urlFetch\":{\"maxURLs\": $LIMIT,\"sitesCriterions\": {\"WHERE\": \"\`Id\`=\\\"$SITE_ID\\\"\"},\"urlsCriterions\": {\"WHERE\": \"NOT (Status=4 AND Crawled=0 AND Processed=0)\", \"LIMIT\": $LIMIT}}}"
            else
              if [ "$2" = "alien" ]; then
                FIELDS="{\"urlFetch\":{\"maxURLs\": $LIMIT,\"sitesCriterions\": {\"WHERE\": \"\`Id\`=\\\"$SITE_ID\\\"\"},\"urlsCriterions\": {\"WHERE\": \"Status=4 AND Crawled=0 AND Processed=0\", \"LIMIT\": $LIMIT}}}"
              else
                if [ "$2" = "new" ]; then
                  FIELDS="{\"urlFetch\":{\"maxURLs\": $LIMIT,\"sitesCriterions\": {\"WHERE\": \"\`Id\`=\\\"$SITE_ID\\\"\"},\"urlsCriterions\": {\"WHERE\": \"Status=1 AND Crawled=0 AND Processed=0\", \"LIMIT\": $LIMIT}}}"
                else
                  echo "not supported fields type"
                  exit
                fi
              fi
            fi
          fi
        fi
      fi
    fi
  fi
fi

../bin/dc-client.py --config=../ini/dc-client.ini --command=URL_CONTENT --file=../data/ftests/dcc_site_url_contents.json --fields="$FIELDS" --mode=1 --merge=0 > ../log/$0.json
../bin/integrity-urlContent.py --stat=0 < ../log/$0.json

if [ "$3" = "r" ]; then
  rm ../log/$0.json
fi
