'''
@package: dc
@author scorp
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2014 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
'''

import Constants
import logging

logger = logging.getLogger(Constants.LOGGER_NAME)


##FieldRecalculator class makes come common processing of databse fields recalculation (using in Task classes)
class FieldRecalculator(object):

  def __init__(self):
    pass


  ##commonSiteRecalculate - common recalculate method
  #
  #@param queryCallback function for queries execution
  #@param additionCause additional SQL cause
  #@param fieldName - processing field name (of `sites` tables)
  #@param siteId - site id
  def commonSiteRecalculate(self, additionCause, fieldName, siteId, queryCallback):
    tableName = Constants.DC_URLS_TABLE_NAME_TEMPLATE % siteId
    query = "SELECT COUNT(*) FROM %s WHERE %s" % (tableName, additionCause)
    res = queryCallback(query, Constants.SECONDARY_DB_ID)
    if res is not None and len(res) > 0 and len(res[0]) > 0:
      logger.debug(">>>RECALCULATOR Site.%s update to %s value", fieldName, str(res[0][0]))
      query = "UPDATE `sites` SET `%s`=%s WHERE `id` = '%s'" % (fieldName, str(res[0][0]), siteId)
      queryCallback(query, Constants.PRIMARY_DB_ID)


  ##siteResourcesRecalculate - recalculate sites.Resources field
  #
  def siteResourcesRecalculate(self, siteId, queryCallback):
    #self.commonSiteRecalculate(queryCallback, "State>3 AND Crawled>0", "Resources", siteId)
    self.commonSiteRecalculate("Crawled>0", "Resources", siteId, queryCallback)


  ##siteContentsRecalculate - recalculate sites.Contents field
  #
  def siteContentsRecalculate(self, siteId, queryCallback):
    #self.commonSiteRecalculate(queryCallback, "State=7 AND Crawled>0 AND Processed>0", "Contents", siteId)
    self.commonSiteRecalculate("Processed>0", "Contents", siteId, queryCallback)


  # updateCollectedURLs updates sites.CollectedURLs field
  #
  # @param siteId - siteId
  # @param queryCallback - callback sql function
  def updateCollectedURLs(self, siteId, queryCallback):
    tableName = ("urls_%s" % str(siteId))
    QUERY_TEMPLATE = "UPDATE `sites` SET `CollectedURLs`=(SELECT count(*) FROM dc_urls.%s) WHERE `Id`='%s'"
    query = QUERY_TEMPLATE % (tableName, siteId)
    queryCallback(query, Constants.PRIMARY_DB_ID)
