'''
@package: dc
@author igor
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2014 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
'''

from BaseTask import BaseTask
from dtm.EventObjects import GeneralResponse
import Constants


##process urlUpdate event
class URLUpdateTask(BaseTask):

  ##constructor
  #
  def __init__(self):
    super(URLUpdateTask, self).__init__()


  ##make all necessary actions to get update urls data in db
  #
  #@param urlUpdates list of URLUpdate objects
  #@param queryCallback function for queries execution
  #@return generalResponse instance of GeneralResponse object
  def process(self, urlUpdates, queryCallback):
    generalResponse = GeneralResponse()
    status = False
    for urlUpdate in urlUpdates:
      status = False
      if urlUpdate.siteId == "":
        urlUpdate.siteId = "0"
      if hasattr(urlUpdate, "urlMd5") == False:
        urlUpdate.fillMD5(urlUpdate.url, urlUpdate.type)
      if self.isSiteExist(urlUpdate.siteId, queryCallback):
        status = self.updateURL(urlUpdate, queryCallback)
      generalResponse.statuses.append(status)
    return generalResponse


  ##update url in db
  #
  #@param urlUpdate instance of URLUpdate object
  #@param queryCallback function for queries execution
  def updateURL(self, urlUpdate, queryCallback):
    ret = False
    SQL_UPDATE_URLSITE_SQL_TEMPLATE = "UPDATE `%s` SET %s"
    fields, values = Constants.getFieldsValuesTuple(urlUpdate, Constants.URLTableDict)
    fieldValueString = Constants.createFieldsValuesString(fields, values)
    if fieldValueString and len(fieldValueString) > 0:
      tableName = Constants.DC_URLS_TABLE_NAME_TEMPLATE % urlUpdate.siteId
      query = SQL_UPDATE_URLSITE_SQL_TEMPLATE %(tableName, fieldValueString)
      additionWhere = None
      if urlUpdate.urlMd5 is not None:
        additionWhere = ("`URLMD5` = '%s'" % urlUpdate.urlMd5)
      additionQueryStr = self.generateCriterionSQL(urlUpdate.criterions, additionWhere)
      if len(additionQueryStr) > 0:
        query += " "
        query += additionQueryStr
      queryCallback(query, Constants.SECONDARY_DB_ID)
      ret = True
    return ret
