"""@package docstring
 @file Constants.py
 @author Alexey <developers.hce@gmail.com>
 @link http://hierarchical-cluster-engine.com/
 @copyright Copyright &copy; 2013 IOIX Ukraine
 @license http://hierarchical-cluster-engine.com/license/
 @package HCE project node API
 @since 0.1
"""


# constants for general purpose
TAG_MEDIA = "media"
TAG_TITLE = "title"
TAG_LINK = "link"
TAG_DESCRIPTION = "description"
TAG_PUB_DATE = "pubdate"
TAG_DC_DATE = "dc_date"
TAG_AUTHOR = "author"
TAG_GUID = "guid"
TAG_CONTENT_UTF8_ENCODED = "content_encoded"
TAG_KEYWORDS = "keywords"
TAG_MEDIA_THUMBNAIL = "media_thumbnail"
TAG_MEDIA_CONTENT = "media_content"
TAG_ENCLOSURE = "enclosure"
TAG_GOOGLE = "google_search"
TAG_GOOGLE_TOTAL = "google_search_total"
HTML_LANG = "html_lang"

# MODES
PROCESS_ALGORITHM_REGULAR = "regular"
PROCESS_ALGORITHM_TRAINING = "training"
PROCESS_ALGORITHM_PREDICTION = "prediction"
PROCESS_ALGORITHM_CONCURRENCY = "concurrency"

TRAINING_QUEUE = "TRAINING_QUEUE"
TRAINED_QUEUE = "TRAINED_QUEUE"
CONCURRENCY_QUEUE = "CONCURRENCY_QUEUE"

DB_SECTION = "mysql"
DB_HOST = "db_host"
DB_PORT = "db_port"
DB_USER = "db_user"
DB_PWD = "db_pwd"
DB_SITES = "db_dc_sites"
DB_URLS = "db_dc_urls"
DB_SCRAPERS = "db_dc_scrapers"

# log messages
MSG_ERROR_OK = ""
MSG_ERROR_LOAD_DB_BACKEND = "Error loading DB backend. "

#staus code
ERROR_OK = 0

# extractor's names
EXTRACTOR_NAME_ML = "ML extractor"

MODULES_KEY = "modules"
ALGORITHM_KEY = "algorithm"
ALGORITHM_NAME_KEY = "algorithm_name"
PROPERTIES_KEY = "properties"
TEMPLATE_KEY = "template"
RANK_KEY = "rank"
USE_HTML5_KEY = "html5"

SCRAPER_RANK_INIT = 10
USE_HTML5_YES = 1
USE_HTML5_NO = 0

TIMEZONE_LIST = ["JST"]

SCRAPER_PROPERTIES_JSON = '{"properties":{"algorithm":{"algorithm_name":"regular"},"modules":{"regular":["ScrapyExtractor","GooseExtractor","NewspaperExtractor"],"concurrency":["NewspaperExtractor", "ScrapyExtractor","GooseExtractor"],"training":["ScrapyExtractor","DiffBotExtractor"],"prediction":["MLExtractor"]}}}'
SCRAPY_PROPERTIES_JSON = '{"properties":{"rank":1,"tags":{"content_encoded":{"rank":1},"pubdate":{"rank":1},"media":{"rank":1},"description":{"rank":1},"author":{"rank":1},"keywords":{"rank":1},"title":{"rank":1},"link":{"rank":1}},"template":"", "html5":1}}'

#ML section

#HTML5 SEMANTIC TASG
class HTML5_SEMANTIC_TAGS(object):

  HEADER = "header"
  FOOTER = "footer"
  ARTICLE = "article"
  SECTION = "section"

  def __init__(self):
    pass