'''
@package: dc
@author scorp
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2014 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
'''
import ppath

import base64
import time
import unittest
import os
import sys
import dtm.EventObjects
import dc.EventObjects
import dc.Constants
import ConfigParser
import hashlib
import dc_db.Constants
import sqlite3
try:
  import cPickle as pickle
except ImportError:
  import pickle
from dc.Constants import EVENT_TYPES
from app.Utils import PathMaker


CMD_SNEW1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_new1.dat")
CMD_SNEW2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_new2.dat")
CMD_SSTATUS1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_status1.dat")
CMD_SSTATUS2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_status2.dat")
CMD_SUPDATE2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_update2.dat")
CMD_SDELETE1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_delete1.dat")
CMD_SCLEANUP2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_cleanup2.dat")


CMD_USITE_NEW1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_site_new1.dat")
CMD_USITE_NEW2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_site_new2.dat")
CMD_UNEW1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_new1.dat")
CMD_USTATUS1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_status1.dat")
CMD_USTATUS2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_status2.dat")
CMD_UFETCH1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_fetch1.dat")
CMD_UFETCH2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_fetch2.dat")
CMD_UNEW2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_new2.dat")
CMD_UNEW3 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_new3.dat")
CMD_USTATUS2_3 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_status2-3.dat")
CMD_UFETCH1_2_3 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_fetch1-2-3.dat")
CMD_UUPDATE2_3_4 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_update2-3-4.dat")
CMD_UCONTENT1_4 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_content1-4.dat")
CMD_UDELETE1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_delete1.dat")
CMD_UDELETE4 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_delete4.dat")
CMD_UCLEANUP1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_cleanup1.dat")
CMD_UCLEANUP2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_cleanup2.dat")
CMD_UFETCH2_3_4 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_fetch2-3-4.dat")
CMD_USTATUS2_3_4 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_status2-3-4.dat")

CMD_USITE_NEW5 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_new5.dat")
CMD_UNEW5 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_new5.dat")
CMD_UCONTENT5 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_content5.dat")
CMD_UCONTENT5_EXT = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_content5_ext.dat")
CMD_UCONTENT5_DYN = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_content5_dyn.dat")

CMD_SNEW_INTEL = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_new_intel.dat")
CMD_UNEW_INTEL = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_new_intel.dat")
CMD_UNEW_INTEL1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_new_intel1.dat")

CMD_UDEL_CRITERIONS_DEL = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_del_criterions_del.dat")
CMD_UDEL_CRITERIONS_FETCH = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_del_criterions_fetch.dat")
CMD_UCLEANUP_CRITERIONS = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_cleanup_criterions.dat")

CMD_SDELETE_BAD = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_delete_bad.dat")

CMD_SUPDATE_CRITERIONS = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_update_criterions.dat")
CMD_SSTATUS_CRITERIONS = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_status_criterions.dat")

CMD_SNEW_44 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_new44.dat")
CMD_SNEW_55 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_new55.dat")
CMD_SUPDATE_5 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_update5.dat")

CMD_UCONTENT_DBFIELDS = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/url_content_dbfields.dat")


CMD_SQLCUSTOM_BAD1 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/sql_custom_bad1.dat")
CMD_SQLCUSTOM_BAD2 = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/sql_custom_bad2.dat")
CMD_SQLCUSTOM_OK = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/sql_custom_ok.dat")
CMD_SINTEL_UPDATE_OK = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_intel1_update.dat")

CMD_SSTATUS_TMP_OK = ("cd ../../bin && /usr/bin/python ./db-task.py --cfg=../ini/db-task.ini " +
        "<../hce/ftests/db-task-data/site_status_tmp.dat")

class Test(unittest.TestCase):

  CD_PATH = "../../bin"
  CLASS_NAME = "TasksManager"
  KEY_VALUE_STORAGE_DIR = "key_value_storage_dir"
  RAW_DATA_DIR = "raw_data_dir"


  def setUp(self):
    self.url = "http://url5.com/"
    self.siteId = "z5"
    self.urlMd5 = hashlib.md5(self.url).hexdigest()


  def tearDown(self):
    pass


  def execCommand(self, command, step):
    obj = None
    fd = os.popen(command)
    if fd:
      localStr = fd.read()
      fd.close()
      try:
        obj = pickle.loads(localStr)
      except EOFError:
        self.assertTrue(False, "Step%s >>> Invalid return data" % str(step))
    return obj


  def checkSStep1(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_NEW_RESPONSE, "Step%s >>> Bad return Event type"  % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dtm.EventObjects.GeneralResponse.ERROR_OK,
                    "Step%s >>> Some Error in Return object" % str(step))


  def checkSStep2(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dc.EventObjects.Site, "Step%s >>> Bad return objsct type" % str(step))
    self.assertTrue(obj.eventObject.state == dc.EventObjects.Site.STATE_NOT_FOUND,
                    "Step%s >>> Wrong 'state' field value" % str(step))


  def checkSStep3(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_NEW_RESPONSE, "Step%s >>> Bad return Event type"  % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dtm.EventObjects.GeneralResponse.ERROR_OK,
                    "Step%s >>> Some Error in Return object" % str(step))


  def checkSStep4(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dc.EventObjects.Site, "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.state != dc.EventObjects.Site.STATE_NOT_FOUND,
                    "Step%s >>> Wrong 'state' field value" % str(step))
    self.assertTrue(obj.eventObject.id == "z2", "Step%s >>> Wrong 'id' field value" % str(step))
    self.assertTrue(obj.eventObject.state == 1, "Step%s >>> Wrong 'state' field value" % str(step))


  def checkSStep5(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_UPDATE_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dtm.EventObjects.GeneralResponse.ERROR_OK,
                    "Step%s >>> Wrong 'errorCode' field value" % str(step))


  def checkSStep6(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_DELETE_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse,
                    "Step%s >>> Bad return object type" % str(step))


  def checkSStep7(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dc.EventObjects.Site, "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.state == dc.EventObjects.Site.STATE_NOT_FOUND,
                    "Step%s >>> Wrong 'state' field value" % str(step))
  
  
  def checkSStep8(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dc.EventObjects.Site, "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.state != dc.EventObjects.Site.STATE_NOT_FOUND,
                    "Step%s >>> Wrong 'state' field value" % str(step))
    self.assertTrue(obj.eventObject.id == "z2", "Step%s >>> Wrong 'id' field value" % str(step))
    self.assertTrue(obj.eventObject.state == 55, "Step%s >>> Wrong 'state' field value" % str(step))
    self.assertTrue(type(obj.eventObject.uDate) == str, "Step%s >>> Wrong 'uDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject.tcDate) == str, "Step%s >>> Wrong 'tcDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject.cDate) == str, "Step%s >>> Wrong 'cDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject.recrawlDate) == str, "Step%s >>> Wrong 'recrawlDate' field type" % str(step))


  def checkSStep9(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_CLEANUP_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dtm.EventObjects.GeneralResponse.ERROR_OK,
                    "Step%s >>> errorCode badvalue" % str(step))


  def checkSStep10(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dc.EventObjects.Site, "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.state != dc.EventObjects.Site.STATE_NOT_FOUND,
                    "Step%s >>> Wrong 'state' field value" % str(step))
    self.assertTrue(obj.eventObject.id == "z2", "Step%s >>> Wrong 'id' field value" % str(step))
    self.assertTrue(obj.eventObject.state == dc.EventObjects.Site.STATE_ACTIVE, 
                    "Step%s >>> Wrong 'state' field value" % str(step))
    self.assertTrue(type(obj.eventObject.properties) == type([]),
                    "Step%s >>> Wrong 'properties' field type" % str(step))
    self.assertTrue(type(obj.eventObject.filters) == type([]),
                    "Step%s >>> Wrong 'filters' field type" % str(step))
    self.assertTrue(len(obj.eventObject.properties) == 2, "Step%s >>> Wrong 'properties' field size" % str(step))
    self.assertTrue(type(obj.eventObject.properties[0]["cDate"]) == str,
                    "Step%s >>> Wrong 'properties[0][cDate]' field value" % str(step))
    self.assertTrue("uDate" not in obj.eventObject.properties[0],
                    "Step%s >>> Wrong 'properties[0][uDate]' field value" % str(step))
    self.assertTrue(len(obj.eventObject.properties) == 2, "Step%s >>> Wrong 'properties' field size" % str(step))
    self.assertTrue(len(obj.eventObject.filters) == 1, "Step%s >>> Wrong 'filters' field size" % str(step))


  def checkUStep1(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_NEW_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse, 
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dtm.EventObjects.GeneralResponse.ERROR_OK,
                    "Step%s >>> GeneralResponse come error" % str(step))
  

  def checkUStep2(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 1, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].siteId == "z1", "Step%s >>> Bad return object [0].siteId value" % str(step))
  

  def checkUStep3(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 0, "Step%s >>> Bad return object len" % str(step))


  def checkUStep4(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_FETCH_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 1, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].siteId == "z1", "Step%s >>> Bad return object [0].siteId value" % str(step))


  def checkUStep5(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_FETCH_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 0, "Step%s >>> Bad return object len" % str(step))


  def checkUStep6(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_NEW_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse, 
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dtm.EventObjects.GeneralResponse.ERROR_OK,
                    "Step%s >>> GeneralResponse come error" % str(step))
  
  
  def checkUStep7(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_NEW_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse, 
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dtm.EventObjects.GeneralResponse.ERROR_OK,
                    "Step%s >>> GeneralResponse come error" % str(step))
  

  def checkUStep8(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 2, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].siteId == "z1", "Step%s >>> Bad return object[0].siteId value" % str(step))
    self.assertTrue(obj.eventObject[0].url == 
                    "http://url2.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    
    self.assertTrue(type(obj.eventObject[0].UDate) == str, "Step%s >>> Wrong 'UDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject[0].CDate) == str, "Step%s >>> Wrong 'CDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject[0].lastModified) == str, 
                    "Step%s >>> Wrong 'lastModified' field type" % str(step))
    self.assertTrue(obj.eventObject[0].tcDate == None, "Step%s >>> Wrong 'tcDate' field type" % str(step))

    self.assertTrue(obj.eventObject[1].siteId == "z2", "Step%s >>> Bad return object[1].siteId value" % str(step))
    self.assertTrue(obj.eventObject[1].url == 
                    "http://url3.com/", "Step%s >>> Bad return object10].url value" % str(step))

    self.assertTrue(type(obj.eventObject[1].UDate) == str, "Step%s >>> Wrong 'UDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject[1].CDate) == str, "Step%s >>> Wrong 'CDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject[1].lastModified) == str, 
                    "Step%s >>> Wrong 'lastModified' field type" % str(step))
    self.assertTrue(obj.eventObject[1].tcDate == None, "Step%s >>> Wrong 'tcDate' field type" % str(step))
    
  
  def checkUStep9(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_FETCH_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 3, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].siteId == "z1", "Step%s >>> Bad return object[0].siteId value" % str(step))
    self.assertTrue(obj.eventObject[0].url == 
                    "http://url1.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(obj.eventObject[0].UDate == None, "Step%s >>> Wrong 'UDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject[0].CDate) == str, "Step%s >>> Wrong 'CDate' field type" % str(step))
    self.assertTrue(obj.eventObject[0].lastModified == None, 
                    "Step%s >>> Wrong 'lastModified' field type" % str(step))
    self.assertTrue(obj.eventObject[0].tcDate == None, "Step%s >>> Wrong 'tcDate' field type" % str(step))
    self.assertTrue(obj.eventObject[1].siteId == "z1", "Step%s >>> Bad return object[1].siteId value" % str(step))
    self.assertTrue(obj.eventObject[1].url == 
                    "http://url2.com/", "Step%s >>> Bad return object[1].url value" % str(step))
    self.assertTrue(type(obj.eventObject[1].UDate) == str, "Step%s >>> Wrong 'UDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject[1].CDate) == str, "Step%s >>> Wrong 'CDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject[1].lastModified) == str, 
                    "Step%s >>> Wrong 'lastModified' field type" % str(step))
    self.assertTrue(obj.eventObject[1].tcDate == None, "Step%s >>> Wrong 'tcDate' field type" % str(step))
    self.assertTrue(obj.eventObject[2].siteId == "z2", "Step%s >>> Bad return object[2].siteId value" % str(step))
    self.assertTrue(obj.eventObject[2].url == 
                    "http://url3.com/", "Step%s >>> Bad return object[2].url value" % str(step))
    self.assertTrue(type(obj.eventObject[2].UDate) == str, "Step%s >>> Wrong 'UDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject[2].CDate) == str, "Step%s >>> Wrong 'CDate' field type" % str(step))
    self.assertTrue(type(obj.eventObject[2].lastModified) == str, 
                    "Step%s >>> Wrong 'lastModified' field type" % str(step))
    self.assertTrue(obj.eventObject[2].tcDate == None, "Step%s >>> Wrong 'tcDate' field type" % str(step))


  def checkUStep10(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_UPDATE_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse, 
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject.statuses) == 4, "Step%s >>> Wrong GeneralResponse.statuses len" % str(step))
    self.assertTrue(obj.eventObject.statuses[0] == True,
                    "Step%s >>> Wrong GeneralResponse.statuses[0] value" % str(step))
    self.assertTrue(obj.eventObject.statuses[1] == True,
                    "Step%s >>> Wrong GeneralResponse.statuses[1] value" % str(step))
    self.assertTrue(obj.eventObject.statuses[2] == False,
                    "Step%s >>> Wrong GeneralResponse.statuses[2] value" % str(step))
    self.assertTrue(obj.eventObject.statuses[3] == True,
                    "Step%s >>> Wrong GeneralResponse.statuses[3] value" % str(step))


  def checkUStep11(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_CONTENT_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 2, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].url ==
                    "http://url1.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(type(obj.eventObject[0].rawContents) == type([]),
                    "Step%s >>> Bad return object[0].rawContent type" % str(step))
    self.assertTrue(len(obj.eventObject[0].rawContents) == 0,
                    "Step%s >>> Bad return object[0].rawContent len" % str(step))
    self.assertTrue(obj.eventObject[1].url == 
                    "http://url4.com/", "Step%s >>> Bad return object[1].url value" % str(step))
    self.assertTrue(type(obj.eventObject[1].rawContents) == type([]),
                    "Step%s >>> Bad return object[1].rawContent type" % str(step))
    self.assertTrue(len(obj.eventObject[1].rawContents) == 0,
                    "Step%s >>> Bad return object[1].rawContent len" % str(step))


  def checkUStep12(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_DELETE_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse, 
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(type(obj.eventObject.statuses) == type([]),
                    "Step%s >>> Bad return object.statuses type" % str(step))
    self.assertTrue(len(obj.eventObject.statuses) == 1, "Step%s >>> Bad return object.statuses len" % str(step))
    self.assertTrue(obj.eventObject.statuses[0] == True, "Step%s >>> Bad return object.statuses[0] value" % str(step))
  
  
  def checkUStep13(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_DELETE_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse, 
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(type(obj.eventObject.statuses) == type([]),
                    "Step%s >>> Bad return object.statuses type" % str(step))
    self.assertTrue(len(obj.eventObject.statuses) == 1, "Step%s >>> Bad return object.statuses len" % str(step))
    self.assertTrue(obj.eventObject.statuses[0] == False, "Step%s >>> Bad return object.statuses[0] value" % str(step))
  

  def checkUStep14(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_CLEANUP_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse, 
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(type(obj.eventObject.statuses) == type([]),
                    "Step%s >>> Bad return object.statuses type" % str(step))
    self.assertTrue(len(obj.eventObject.statuses) == 1, "Step%s >>> Bad return object.statuses len" % str(step))
    self.assertTrue(obj.eventObject.statuses[0] == False, "Step%s >>> Bad return object.statuses[0] value" % str(step))
    
  
  def checkUStep15(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_CLEANUP_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse, 
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(type(obj.eventObject.statuses) == type([]),
                    "Step%s >>> Bad return object.statuses type" % str(step))
    self.assertTrue(len(obj.eventObject.statuses) == 1, "Step%s >>> Bad return object.statuses len" % str(step))
    self.assertTrue(obj.eventObject.statuses[0] == False, "Step%s >>> Bad return object.statuses[0] value" % str(step))
  

  def checkUStep16(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_FETCH_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 1, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].siteId == "z2", "Step%s >>> Bad return object[0].siteId value" % str(step))
    self.assertTrue(obj.eventObject[0].url == 
                    "http://url3.com/", "Step%s >>> Bad return object[0].url value" % str(step))


  def checkUStep17(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 2, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].siteId == "z1", "Step%s >>> Bad return object[0].siteId value" % str(step))
    self.assertTrue(obj.eventObject[0].url == 
                    "http://url2.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(obj.eventObject[1].siteId == "z2", "Step%s >>> Bad return object[1].siteId value" % str(step))
    self.assertTrue(obj.eventObject[1].url == 
                    "http://url3.com/", "Step%s >>> Bad return object[0].url value" % str(step))


  def checkCStep1(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_CONTENT_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 3, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].url == 
                    "http://url1.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(type(obj.eventObject[0].rawContents) == type([]),
                    "Step%s >>> Bad return object[0].rawContent type" % str(step))
    self.assertTrue(len(obj.eventObject[0].rawContents) == 0,
                    "Step%s >>> Bad return object[0].rawContent len" % str(step))

    self.assertTrue(type(obj.eventObject[0].processedContents) == type([]),
                    "Step%s >>> Bad return object[0].processedContents type" % str(step))
    self.assertTrue(len(obj.eventObject[0].processedContents) == 0,
                    "Step%s >>> Bad return object[0].processedContents len" % str(step))
    self.assertTrue(obj.eventObject[1].url == 
                    "http://url5.com/", "Step%s >>> Bad return object[1].url value" % str(step))
    self.assertTrue(type(obj.eventObject[1].rawContents) == type([]),
                    "Step%s >>> Bad return object[1].rawContent type" % str(step))

    self.assertTrue(len(obj.eventObject[1].rawContents) == 2,
                    "Step%s >>> Bad return object[1].rawContent len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].rawContents[0].buffer)
    self.assertTrue(baseStr == "EEEEE",
                    "Step%s >>> Bad return obj.eventObject[1].rawContents[1].buffer value" % str(step))
    print(obj.eventObject[1].rawContents[0].cDate)
    self.assertTrue(len(obj.eventObject[1].processedContents) == 1,
                    "Step%s >>> Bad return object[1].processedContents len" % str(step))
    self.assertTrue(obj.eventObject[1].processedContents[0].buffer == "EEEEE",
                    "Step%s >>> Bad return obj.processedContents[1].rawContents[0].buffer value" % str(step))
    print(obj.eventObject[1].rawContents[0].cDate)
    baseStr = base64.b64decode(obj.eventObject[1].rawContents[1].buffer)
    self.assertTrue(baseStr == "ArashTIDY",
                    "Step%s >>> Bad return obj.eventObject[1].rawContents[1].buffer value" % str(step))
    self.assertTrue(obj.eventObject[1].rawContents[1].fieldId == dc.EventObjects.Content.CONTENT_TIDY_CONTENT,
                    "Step%s >>> Bad return obj.eventObject[1].rawContents[1].fieldId value" % str(step))
    print(obj.eventObject[1].rawContents[1].cDate)

    self.assertTrue(obj.eventObject[2].url == 
                    "http://url5.com/", "Step%s >>> Bad return object[1].url value" % str(step))
    self.assertTrue(type(obj.eventObject[2].rawContents) == type([]),
                    "Step%s >>> Bad return object[1].rawContent type" % str(step))
    self.assertTrue(len(obj.eventObject[2].rawContents) == 10,
                    "Step%s >>> Bad return object[2].rawContent len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[0].buffer)
    self.assertTrue(baseStr == "EEEEE",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[0].buffer value" % str(step))
    print(obj.eventObject[2].rawContents[0].cDate)
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[1].buffer)
    self.assertTrue(baseStr == "AAAAA",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[1].buffer value" % str(step))
    print(obj.eventObject[2].rawContents[1].cDate)
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[2].buffer)
    self.assertTrue(baseStr == "AAAAA",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[2].buffer value" % str(step))
    print(obj.eventObject[2].rawContents[2].cDate)
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[3].buffer)
    self.assertTrue(baseStr == "BBBBB",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[3].buffer value" % str(step))
    print(obj.eventObject[2].rawContents[3].cDate)
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[4].buffer)
    self.assertTrue(baseStr == "CCCCC",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[4].buffer value" % str(step))
    print(obj.eventObject[2].rawContents[4].cDate)
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[5].buffer)
    self.assertTrue(baseStr == "EEEEE",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[5].buffer value" % str(step))
    print(obj.eventObject[2].rawContents[5].cDate)
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[6].buffer)
    self.assertTrue(baseStr == "ArashTIDY",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[6].buffer value" % str(step))
    self.assertTrue(obj.eventObject[2].rawContents[6].fieldId == dc.EventObjects.Content.CONTENT_TIDY_CONTENT,
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[6].fieldId value" % str(step))
    print(obj.eventObject[2].rawContents[6].cDate)

    baseStr = base64.b64decode(obj.eventObject[2].rawContents[7].buffer)
    self.assertTrue(baseStr == "AAATIDY",
                    "Step%s >>> Bad return obj.eventObject[1].rawContents[7].buffer value" % str(step))
    self.assertTrue(obj.eventObject[2].rawContents[7].fieldId == dc.EventObjects.Content.CONTENT_TIDY_CONTENT,
                    "Step%s >>> Bad return obj.eventObject[1].rawContents[7].fieldId value" % str(step))
    print(obj.eventObject[2].rawContents[7].cDate)
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[8].buffer)
    self.assertTrue(baseStr == "AAATIDY",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[8].buffer value" % str(step))
    self.assertTrue(obj.eventObject[2].rawContents[8].fieldId == dc.EventObjects.Content.CONTENT_TIDY_CONTENT,
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[8].fieldId value" % str(step))
    print(obj.eventObject[2].rawContents[8].cDate)
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[9].buffer)
    self.assertTrue(baseStr == "ArashTIDY",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[9].buffer value" % str(step))
    self.assertTrue(obj.eventObject[2].rawContents[9].fieldId == dc.EventObjects.Content.CONTENT_TIDY_CONTENT,
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[9].fieldId value" % str(step))
    print(obj.eventObject[2].rawContents[9].cDate)
    self.assertTrue(len(obj.eventObject[1].processedContents) == 1,
                    "Step%s >>> Bad return object[1].processedContents len" % str(step))
    self.assertTrue(obj.eventObject[1].processedContents[0].buffer == "EEEEE",
                    "Step%s >>> Bad return obj.processedContents[1].rawContents[0].buffer value" % str(step))
    print(obj.eventObject[1].processedContents[0].cDate)


  def checkCStep2(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_CONTENT_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 3, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].url == 
                    "http://url1.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(type(obj.eventObject[0].rawContents) == type([]),
                    "Step%s >>> Bad return object[0].rawContent type" % str(step))
    self.assertTrue(len(obj.eventObject[0].rawContents) == 0,
                    "Step%s >>> Bad return object[0].rawContent len" % str(step))

    self.assertTrue(type(obj.eventObject[0].processedContents) == type([]),
                    "Step%s >>> Bad return object[0].processedContents type" % str(step))
    self.assertTrue(len(obj.eventObject[0].processedContents) == 0,
                    "Step%s >>> Bad return object[0].processedContents len" % str(step))
    self.assertTrue(type(obj.eventObject[0].headers) == type([]),
                    "Step%s >>> Bad return object[0].headers type" % str(step))
    self.assertTrue(len(obj.eventObject[0].headers) == 0,
                    "Step%s >>> Bad return object[0].headers len" % str(step))
    self.assertTrue(type(obj.eventObject[0].requests) == type([]),
                    "Step%s >>> Bad return object[0].requests type" % str(step))
    self.assertTrue(len(obj.eventObject[0].requests) == 0,
                    "Step%s >>> Bad return object[0].requests len" % str(step))
    self.assertTrue(type(obj.eventObject[0].meta) == type([]),
                    "Step%s >>> Bad return object[0].meta type" % str(step))
    self.assertTrue(len(obj.eventObject[0].meta) == 0,
                    "Step%s >>> Bad return object[0].meta len" % str(step))
    self.assertTrue(type(obj.eventObject[0].cookies) == type([]),
                    "Step%s >>> Bad return object[0].cookies type" % str(step))
    self.assertTrue(len(obj.eventObject[0].cookies) == 0,
                    "Step%s >>> Bad return object[0].cookies len" % str(step))

    self.assertTrue(obj.eventObject[1].url == 
                    "http://url5.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(type(obj.eventObject[1].rawContents) == type([]),
                    "Step%s >>> Bad return object[1].rawContent type" % str(step))
    self.assertTrue(len(obj.eventObject[1].rawContents) == 8,
                    "Step%s >>> Bad return object[1].rawContent len" % str(step))
    self.assertTrue(len(obj.eventObject[1].headers) == 5,
                    "Step%s >>> Bad return object[1].headers len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].headers[0].buffer)
    self.assertTrue(baseStr == "AAAAAheaders",
                    "Step%s >>> Bad return obj.eventObject[1].headers[0].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].headers[1].buffer)
    self.assertTrue(baseStr == "AAAAAheaders",
                    "Step%s >>> Bad return obj.eventObject[1].headers[1].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].headers[2].buffer)
    self.assertTrue(baseStr == "BBBBBheaders",
                    "Step%s >>> Bad return obj.eventObject[1].headers[2].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].headers[3].buffer)
    self.assertTrue(baseStr == "CCCCCheaders",
                    "Step%s >>> Bad return obj.eventObject[1].headers[3].buffer value" % str(step))
    self.assertTrue(len(obj.eventObject[1].requests) == 5,
                    "Step%s >>> Bad return object[1].requests len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].requests[0].buffer)
    self.assertTrue(baseStr == "AAAAArequests",
                    "Step%s >>> Bad return obj.eventObject[1].requests[0].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].requests[1].buffer)
    self.assertTrue(baseStr == "AAAAArequests",
                    "Step%s >>> Bad return obj.eventObject[1].requests[1].buffer value" % str(step))
    self.assertTrue(obj.eventObject[1].requests[2] == None,
                    "Step%s >>> Bad return obj.eventObject[1].requests[2].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].requests[3].buffer)
    self.assertTrue(baseStr == "CCCCCrequests",
                    "Step%s >>> Bad return obj.eventObject[1].requests[3].buffer value" % str(step))
    self.assertTrue(len(obj.eventObject[1].meta) == 5,
                    "Step%s >>> Bad return object[1].meta len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].meta[0].buffer)
    self.assertTrue(baseStr == "AAAAAmeta",
                    "Step%s >>> Bad return obj.eventObject[1].meta[0].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].meta[1].buffer)
    self.assertTrue(baseStr == "AAAAAmeta",
                    "Step%s >>> Bad return obj.eventObject[1].meta[1].buffer value" % str(step))
    self.assertTrue(obj.eventObject[1].meta[2] == None,
                    "Step%s >>> Bad return obj.eventObject[1].meta[2].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].meta[3].buffer)
    self.assertTrue(baseStr == "CCCCCmeta",
                    "Step%s >>> Bad return obj.eventObject[1].meta[3].buffer value" % str(step))
    self.assertTrue(len(obj.eventObject[1].cookies) == 5,
                    "Step%s >>> Bad return object[1].cookies len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].cookies[0].buffer)
    self.assertTrue(baseStr == "AAAAAcookies",
                    "Step%s >>> Bad return obj.eventObject[1].cookies[0].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].cookies[1].buffer)
    self.assertTrue(baseStr == "AAAAAcookies",
                    "Step%s >>> Bad return obj.eventObject[1].cookies[1].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].cookies[2].buffer)
    self.assertTrue(baseStr == "BBBBBcookies",
                    "Step%s >>> Bad return obj.eventObject[1].cookies[2].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].cookies[3].buffer)
    self.assertTrue(baseStr == "CCCCCcookies",
                    "Step%s >>> Bad return obj.eventObject[1].cookies[3].buffer value" % str(step))
    
    self.assertTrue(obj.eventObject[2].url == 
                    "http://url5.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(type(obj.eventObject[2].rawContents) == type([]),
                    "Step%s >>> Bad return object[2].rawContent type" % str(step))
    self.assertTrue(len(obj.eventObject[2].rawContents) == 8,
                    "Step%s >>> Bad return object[2].rawContent len" % str(step))
    self.assertTrue(len(obj.eventObject[2].headers) == 5,
                    "Step%s >>> Bad return object[2].headers len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].headers[0].buffer)
    self.assertTrue(baseStr == "AAAAAheaders",
                    "Step%s >>> Bad return obj.eventObject[2].headers[0].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].headers[1].buffer)
    self.assertTrue(baseStr == "AAAAAheaders",
                    "Step%s >>> Bad return obj.eventObject[2].headers[1].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].headers[2].buffer)
    self.assertTrue(baseStr == "BBBBBheaders",
                    "Step%s >>> Bad return obj.eventObject[2].headers[2].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].headers[3].buffer)
    self.assertTrue(baseStr == "CCCCCheaders",
                    "Step%s >>> Bad return obj.eventObject[2].headers[3].buffer value" % str(step))
    self.assertTrue(len(obj.eventObject[2].requests) == 5,
                    "Step%s >>> Bad return object[2].requests len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].requests[0].buffer)
    self.assertTrue(baseStr == "AAAAArequests",
                    "Step%s >>> Bad return obj.eventObject[2].requests[0].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].requests[1].buffer)
    self.assertTrue(baseStr == "AAAAArequests",
                    "Step%s >>> Bad return obj.eventObject[2].requests[1].buffer value" % str(step))
    self.assertTrue(obj.eventObject[2].requests[2] == None,
                    "Step%s >>> Bad return obj.eventObject[2].requests[2].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].requests[3].buffer)
    self.assertTrue(baseStr == "CCCCCrequests",
                    "Step%s >>> Bad return obj.eventObject[2].requests[3].buffer value" % str(step))
    self.assertTrue(len(obj.eventObject[2].meta) == 5,
                    "Step%s >>> Bad return object[2].meta len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].meta[0].buffer)
    self.assertTrue(baseStr == "AAAAAmeta",
                    "Step%s >>> Bad return obj.eventObject[2].meta[0].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].meta[1].buffer)
    self.assertTrue(baseStr == "AAAAAmeta",
                    "Step%s >>> Bad return obj.eventObject[2].meta[1].buffer value" % str(step))
    self.assertTrue(obj.eventObject[2].meta[2] == None,
                    "Step%s >>> Bad return obj.eventObject[2].meta[2].buffer value" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].meta[3].buffer)
    self.assertTrue(baseStr == "CCCCCmeta",
                    "Step%s >>> Bad return obj.eventObject[2].meta[3].buffer value" % str(step))
    self.assertTrue(len(obj.eventObject[2].cookies) == 0,
                    "Step%s >>> Bad return object[2].cookies len" % str(step))


  def checkCStep3(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_CONTENT_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 3, "Step%s >>> Bad return object len" % str(step))

    self.assertTrue(obj.eventObject[1].url == 
                    "http://url5.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(type(obj.eventObject[1].rawContents) == type([]),
                    "Step%s >>> Bad return object[1].rawContent type" % str(step))
    self.assertTrue(len(obj.eventObject[1].rawContents) == 7,
                    "Step%s >>> Bad return object[1].rawContent len" % str(step))
    self.assertTrue(len(obj.eventObject[1].headers) == 5,
                    "Step%s >>> Bad return object[1].headers len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[1].rawContents[6].buffer)
    self.assertTrue(baseStr == "AAADYN",
                    "Step%s >>> Bad return obj.eventObject[1].rawContents[6].buffer value" % str(step))
    self.assertTrue(obj.eventObject[1].rawContents[6].fieldId == dc.EventObjects.Content.CONTENT_DYNAMIC_CONTENT,
                    "Step%s >>> Bad return obj.eventObject[1].rawContents[6].fieldId value" % str(step))
    print(obj.eventObject[1].rawContents[6].cDate)
    
    self.assertTrue(obj.eventObject[2].url == 
                    "http://url5.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(type(obj.eventObject[2].rawContents) == type([]),
                    "Step%s >>> Bad return object[2].rawContent type" % str(step))
    self.assertTrue(len(obj.eventObject[2].rawContents) == 7,
                    "Step%s >>> Bad return object[2].rawContent len" % str(step))
    self.assertTrue(len(obj.eventObject[2].headers) == 5,
                    "Step%s >>> Bad return object[2].headers len" % str(step))
    baseStr = base64.b64decode(obj.eventObject[2].rawContents[6].buffer)
    self.assertTrue(baseStr == "AAADYN",
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[6].buffer value" % str(step))
    self.assertTrue(obj.eventObject[2].rawContents[6].fieldId == dc.EventObjects.Content.CONTENT_DYNAMIC_CONTENT,
                    "Step%s >>> Bad return obj.eventObject[2].rawContents[6].fieldId value" % str(step))
    print(obj.eventObject[2].rawContents[6].cDate)
    

  def checkIntelStep0(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_NEW_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dtm.EventObjects.GeneralResponse.ERROR_OK,
                    "Step%s >>> Some Error in Return object" % str(step))
    self.assertTrue(len(obj.eventObject.statuses) == 1, "Step%s >>> obj.eventObject.statuses len != 1" % str(step))
    self.assertTrue(obj.eventObject.statuses[0] == "intel1", "Step%s >>> obj.eventObject.statuses[0] != \"intel1\"" 
                    % str(step))


  def checkIntelStep3(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_NEW_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dc_db.Constants.TASK_DUBLICATE_ERR,
                    "Step%s >>> Some Error in Return object" % str(step))
    self.assertTrue(len(obj.eventObject.statuses) == 1, "Step%s >>> obj.eventObject.statuses len != 1" % str(step))
    self.assertTrue(obj.eventObject.statuses[0] == None, "Step%s >>> obj.eventObject.statuses[3] != None"
                    % str(step))


  def checkCriterions2(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_FETCH_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 2, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].siteId == "intel1", "Step%s >>> Bad return object[0].siteId value" % str(step))
    self.assertTrue(obj.eventObject[0].url == 
                    "http://intel.com/path1/path2", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(obj.eventObject[0].state == 77, "Step%s >>> Bad return object[1].state value" % str(step))
    self.assertTrue(obj.eventObject[0].status == 77, "Step%s >>> Bad return object[1].status value" % str(step))
    self.assertTrue(obj.eventObject[1].siteId == "intel1", "Step%s >>> Bad return object[1].siteId value" % str(step))
    self.assertTrue(obj.eventObject[1].url == 
                    "http://intel.com/path1/", "Step%s >>> Bad return object[1].url value" % str(step))
    
    
  def checkDeleteBad(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_DELETE_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errorCode == dtm.EventObjects.GeneralResponse.ERROR_OK,
                    "Step%s >>> Wrong obj.eventObject.errorCode value" % str(step))
    self.assertTrue(obj.eventObject.errorMessage == "",
                    "Step%s >>> Wrong obj.eventObject.errorMessage value" % str(step))


  def checkSiteCriterions1(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_UPDATE_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dtm.EventObjects.GeneralResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject.statuses) == 1, "Step%s >>> Bad return object statuses len" % str(step))
    for status in obj.eventObject.statuses:
      self.assertTrue(status == dtm.EventObjects.GeneralResponse.ERROR_OK, 
                      "Step%s >>> Bad return object statuses value" % str(step))


  def checkSiteCriterions2(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dc.EventObjects.Site, "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.maxResources == 6688, 
                    "Step%s >>> Bad return eventObject.maxResources value" % str(step))
    
    
  def checkURLContentBDFields(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.URL_CONTENT_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == type([]), "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(len(obj.eventObject) == 2, "Step%s >>> Bad return object len" % str(step))
    self.assertTrue(obj.eventObject[0].url == 
                    "http://url1.com/", "Step%s >>> Bad return object[0].url value" % str(step))
    self.assertTrue(type(obj.eventObject[0].dbFields) == type({}), 
                    "Step%s >>> Wrong object[0].dbFields type" % str(step))
    self.assertTrue(len(obj.eventObject[0].dbFields) == 0,
                    "Step%s >>> Wrong object[0].dbFields len" % str(step))
    self.assertTrue(obj.eventObject[1].url == 
                    "http://url1.com/", "Step%s >>> Bad return object[1].url value" % str(step))
    self.assertTrue(type(obj.eventObject[1].dbFields) == type({}), 
                    "Step%s >>> Wrong object[1].dbFields type" % str(step))
    self.assertTrue(len(obj.eventObject[1].dbFields) == 4,
                    "Step%s >>> Wrong object[1].dbFields len" % str(step))
    self.assertTrue(obj.eventObject[1].dbFields["CDate"] != None,
                    "Step%s >>> Wrong object[1].dbFields[CDate] value" % str(step))
    self.assertTrue(obj.eventObject[1].dbFields["RawContentMd5"] != None,
                    "Step%s >>> Wrong object[1].dbFields[RawContentMd5] value" % str(step))
    self.assertTrue(obj.eventObject[1].dbFields["MRate"] != None,
                    "Step%s >>> Wrong object[1].dbFields[MRate] value" % str(step))
    self.assertTrue(obj.eventObject[1].dbFields["emptyF"] == None,
                    "Step%s >>> Wrong object[1].dbFields[emptyF] value" % str(step))


  def checkSQLCustom1(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SQL_CUSTOM_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dc.EventObjects.CustomResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errString == "Error: wrong SQL request or DBName")
    self.assertTrue(type(obj.eventObject.result) == tuple)
    self.assertTrue(len(obj.eventObject.result) == 0)


  def checkSQLCustom2(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SQL_CUSTOM_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dc.EventObjects.CustomResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errString == "Error: wrong SQL request or DBName")
    self.assertTrue(type(obj.eventObject.result) == tuple)
    self.assertTrue(len(obj.eventObject.result) == 0)


  def checkSQLCustom3(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SQL_CUSTOM_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    self.assertTrue(type(obj.eventObject) == dc.EventObjects.CustomResponse,
                    "Step%s >>> Bad return object type" % str(step))
    self.assertTrue(obj.eventObject.errString is None)
    self.assertTrue(type(obj.eventObject.result) == tuple)
    self.assertTrue(len(obj.eventObject.result) > 0)
    
  
  def checkSStatusUrls(self, obj, step):
    self.assertTrue(type(obj) == dc.Constants.DRCESyncTasksCover, "Step%s >>> Bad return type" % str(step))
    self.assertTrue(obj.eventType == EVENT_TYPES.SITE_STATUS_RESPONSE, "Step%s >>> Bad return Event type" % str(step))
    print obj.eventObject.id
    print obj.eventObject.contents
    print obj.eventObject.urls
    print obj.eventObject.urls[0].__dict__
#    print obj.eventObject.urls[0].UDate.__dict__


  def fileCreate(self, directory, fName, data):
    time.sleep(3)
    fd = open(directory + "/" + fName, "w")
    fd.write(data)
    fd.close()


  def makeContent(self):
    savePath = os.getcwd()
    os.chdir(self.CD_PATH)
    configParser = ConfigParser.ConfigParser()
    configParser.read("../ini/db-task.ini")
    keyValueStorageDir = configParser.get(self.CLASS_NAME, self.KEY_VALUE_STORAGE_DIR)
    rawDataDir = configParser.get(self.CLASS_NAME, self.RAW_DATA_DIR)
    print(keyValueStorageDir + "\n" + rawDataDir)
# Files creating
    dataDir = rawDataDir + "/" + self.siteId +"/"+ PathMaker(self.urlMd5).getDir()
    os.makedirs(dataDir)
    self.fileCreate(dataDir, "A1.bin", "AAAAA")
    self.fileCreate(dataDir, "A1.headers.txt", "AAAAAheaders")
    self.fileCreate(dataDir, "A1.requests.txt", "AAAAArequests")
    self.fileCreate(dataDir, "A1.meta.txt", "AAAAAmeta")
    self.fileCreate(dataDir, "A1.cookies.txt", "AAAAAcookies")
    self.fileCreate(dataDir, "A1.tidy", "AAATIDY")
    self.fileCreate(dataDir, "B1.bin", "BBBBB")
    self.fileCreate(dataDir, "B1.headers.txt", "BBBBBheaders")
    self.fileCreate(dataDir, "B1.cookies.txt", "BBBBBcookies")
    self.fileCreate(dataDir, "C1.bin", "CCCCC")
    self.fileCreate(dataDir, "C1.headers.txt", "CCCCCheaders")
    self.fileCreate(dataDir, "C1.requests.txt", "CCCCCrequests")
    self.fileCreate(dataDir, "C1.meta.txt", "CCCCCmeta")
    self.fileCreate(dataDir, "C1.cookies.txt", "CCCCCcookies")
    self.fileCreate(dataDir, "D1.meta.txt", "DDDDDmeta")
    self.fileCreate(dataDir, "E1.bin", "EEEEE")
    self.fileCreate(dataDir, "arash.tidy", "ArashTIDY")
    self.fileCreate(dataDir, "arash.dyn", "AAADYN")
# KV_DB creating
    localUrlContent = dc.EventObjects.URLContentRequest(0 , "http")
    dbName = dc_db.Constants.KEY_VALUE_FILE_NAME_TEMPLATE % self.siteId
    dbFileName = keyValueStorageDir + "/" + dbName
    INSERT_SQL = "INSERT INTO `articles` (Id, Data, CDate) VALUES('%s', '%s', %s)"
    localUrlMD5 = localUrlContent.fillMD5(self.url)
    query = INSERT_SQL % (localUrlMD5, "EEEEE", str(int(time.time())))
    if os.path.exists(dbFileName):
      dbConnect = sqlite3.connect(dbFileName)
      dbConnect.text_factory = str
      cursor = dbConnect.cursor()
      cursor.execute(query)
      dbConnect.commit()
    os.chdir(savePath)


  def testCommonSiteSuite(self):
    obj = self.execCommand(CMD_SNEW1, 1)
    if obj != None:
      self.checkSStep1(obj, 1)
    obj = self.execCommand(CMD_SSTATUS2, 2)
    if obj != None:
      self.checkSStep2(obj, 2)
    obj = self.execCommand(CMD_SNEW2, 3)
    if obj != None:
      self.checkSStep3(obj, 3)
    obj = self.execCommand(CMD_SSTATUS2, 4)
    if obj != None:
      self.checkSStep4(obj, 4)
    obj = self.execCommand(CMD_SUPDATE2, 5)
    if obj != None:
      self.checkSStep5(obj, 5)
    obj = self.execCommand(CMD_SDELETE1, 6)
    if obj != None:
      self.checkSStep6(obj, 6)
    obj = self.execCommand(CMD_SSTATUS1, 7)
    if obj != None:
      self.checkSStep7(obj, 7)
    obj = self.execCommand(CMD_SSTATUS2, 8)
    if obj != None:
      self.checkSStep8(obj, 8)
    obj = self.execCommand(CMD_SCLEANUP2, 9)
    if obj != None:
      self.checkSStep9(obj, 9)
    obj = self.execCommand(CMD_SSTATUS2, 10)
    if obj != None:
      self.checkSStep10(obj, 10)


  def testCommonURLSuite(self):
    self.execCommand(CMD_USITE_NEW1, 0)
    self.execCommand(CMD_USITE_NEW2, 0)
    obj = self.execCommand(CMD_UNEW1, 1)
    if obj != None:
      self.checkUStep1(obj, 1)
    obj = self.execCommand(CMD_USTATUS1, 2)
    if obj != None:
      self.checkUStep2(obj, 2)
    obj = self.execCommand(CMD_USTATUS2, 3)
    if obj != None:
      self.checkUStep3(obj, 3)
    obj = self.execCommand(CMD_UFETCH1, 4)
    if obj != None:
      self.checkUStep4(obj, 4)
    obj = self.execCommand(CMD_UFETCH2, 5)
    if obj != None:
      self.checkUStep5(obj, 5)
    obj = self.execCommand(CMD_UNEW2, 6)
    if obj != None:
      self.checkUStep6(obj, 6)
    obj = self.execCommand(CMD_UNEW3, 7)
    if obj != None:
      self.checkUStep7(obj, 7)
    obj = self.execCommand(CMD_USTATUS2_3, 8)
    if obj != None:
      self.checkUStep8(obj, 8)
    obj = self.execCommand(CMD_UFETCH1_2_3, 9)
    if obj != None:
      self.checkUStep9(obj, 9)
    obj = self.execCommand(CMD_UUPDATE2_3_4, 10)
    if obj != None:
      self.checkUStep10(obj, 10)
    obj = self.execCommand(CMD_UCONTENT1_4, 11)
    if obj != None:
      self.checkUStep11(obj, 11)
    obj = self.execCommand(CMD_UDELETE1, 12)
    if obj != None:
      self.checkUStep12(obj, 12)
    obj = self.execCommand(CMD_UDELETE4, 13)
    if obj != None:
      self.checkUStep13(obj, 13)
    obj = self.execCommand(CMD_UCLEANUP1, 14)
    if obj != None:
      self.checkUStep14(obj, 14)
    obj = self.execCommand(CMD_UCLEANUP2, 15)
    if obj != None:
      self.checkUStep15(obj, 15)
    obj = self.execCommand(CMD_UFETCH2_3_4, 16)
    if obj != None:
      self.checkUStep16(obj, 16)
    obj = self.execCommand(CMD_USTATUS2_3_4, 17)
    if obj != None:
      self.checkUStep17(obj, 17)


  def testURLContent(self):
    self.execCommand(CMD_USITE_NEW5, 0)
    self.execCommand(CMD_UNEW5, 0)
    self.makeContent()
    obj = self.execCommand(CMD_UCONTENT5, 1)
    if obj != None:
      self.checkCStep1(obj, 1)
    obj = self.execCommand(CMD_UCONTENT5_EXT, 2)
    if obj != None:
      self.checkCStep2(obj, 2)
    obj = self.execCommand(CMD_UCONTENT5_DYN, 3)
    if obj != None:
      self.checkCStep3(obj, 3)


  def testUrlNewSiteExtractor(self):
    obj = self.execCommand(CMD_SNEW_INTEL, 0)
    if obj != None:
      self.checkIntelStep0(obj, 0)
    self.execCommand(CMD_UNEW_INTEL, 1)
    obj = self.execCommand(CMD_UNEW_INTEL1, 2)
    obj = self.execCommand(CMD_SNEW_INTEL, 3)
    if obj != None:
      self.checkIntelStep3(obj, 3)


  def test_AdditionCriterions(self):
    self.execCommand(CMD_UDEL_CRITERIONS_DEL, 0)
    self.execCommand(CMD_UCLEANUP_CRITERIONS, 1)
    obj = self.execCommand(CMD_UDEL_CRITERIONS_FETCH, 2)
    if obj != None:
      self.checkCriterions2(obj, 2)


  def test_DeleteAbsentSite(self):
    obj = self.execCommand(CMD_SDELETE_BAD, 0)
    if obj != None:
      self.checkDeleteBad(obj, 0)


  def test_SiteNewCriterions(self):
    obj = self.execCommand(CMD_SUPDATE_CRITERIONS, 0)
    if obj != None:
      self.checkSiteCriterions1(obj, 0)
    obj = self.execCommand(CMD_SSTATUS_CRITERIONS, 1)
    if obj != None:
      self.checkSiteCriterions2(obj, 1)


  def test_SiteNewProp(self):
    self.execCommand(CMD_SNEW_44, 0)
    self.execCommand(CMD_SNEW_55, 0)
    self.execCommand(CMD_SUPDATE_5, 0)


  def test_URLContentDBFields(self):
    obj = self.execCommand(CMD_UCONTENT_DBFIELDS, 0)
    if obj != None:
      self.checkURLContentBDFields(obj, 0)
      

  def test_SQLCommon(self):
    obj = self.execCommand(CMD_SQLCUSTOM_BAD1, 0)
    if obj != None:
      self.checkSQLCustom1(obj, 0)
    obj = self.execCommand(CMD_SQLCUSTOM_BAD1, 1)
    if obj != None:
      self.checkSQLCustom2(obj, 1)
    obj = self.execCommand(CMD_SQLCUSTOM_OK, 2)
    if obj != None:
      self.checkSQLCustom3(obj, 2)


  def test_Common1(self):
    self.execCommand(CMD_SNEW_INTEL, 0)
    self.execCommand(CMD_SINTEL_UPDATE_OK, 1)

  '''
  def test_SStatus(self):
    obj = self.execCommand(CMD_SSTATUS_TMP_OK, 0)
    if obj != None:
      self.checkSStatusUrls(obj, 0)
  '''
if __name__ == "__main__":
  #import sys;sys.argv = ['', 'Test.testName']
  unittest.main()