/**
 * @file DRCEJsonMessageConst.hpp"
 *
 * Declaration const list need for Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_JSON_MESSAGE_CONST_HPP
#define DRCE_JSON_MESSAGE_CONST_HPP

#include <iostream>

namespace HCE
{
namespace drce
{
namespace drce_json_message_const
{
//-----------------------------------------------------------------------------
  // session options
  const std::string sessionType = "type";
  const std::string port = "port";
  const std::string userName = "user";
  const std::string userPassword = "password";
  const std::string shellName = "shell";
  const std::string environment = "environment";
  const std::string homeDir = "home_directory";
  const std::string timeout = "timeout";
  const std::string tmode = "tmode";
  const std::string timeMax = "time_max";
  const std::string cleanup = "cleanup";
  // resource limits
  const std::string procMax = "proc_max";
  const std::string threadsMax = "threads_max";
  const std::string cpu = "cpu";
  const std::string iowait = "iowait";
  const std::string vramFree = "vram_free";
  const std::string vramFreeMin = "vram_free_min";
  const std::string rramFree = "rram_free";
  const std::string rramFreeMin = "rram_free_min";
  const std::string diskFree = "disk_free";
  const std::string diskFreeMin = "disk_free_min";
  // file item
  const std::string fileName = "name";
  const std::string fileData = "data";
  const std::string actionTypeMask = "action";
  // input json message
  const std::string requestType = "type";
  const std::string requestData = "data";
  const std::string requestId = "id";
  const std::string subtasksArray = "subtasks";
  // task execute request
  const std::string sessionOptions = "session";
  const std::string commandLine = "command";
  const std::string inputStream = "input";
  const std::string resourceLimits = "limits";
  // task check state
  const std::string checkType = "type";
  // task fetch type
  const std::string fetchType = "type";
  // task terminate
  const std::string algorithmType = "alg";
  const std::string delayValue = "delay";
  const std::string repeatValue = "repeat";
  const std::string signalValue = "signal";
  // output json message
  const std::string errorCode = "error_code";
  const std::string errorMessage = "error_message";
  const std::string state = "state";
  const std::string pid = "pid";
  const std::string responseBody = "data";
  const std::string elapsedTime = "time";
  const std::string nodeHost = "host";
  const std::string nodePort = "port";
  // result data
  const std::string stdoutStream = "stdout";
  const std::string stderrStream = "stderror";
  const std::string filesArray = "files";
  const std::string nodeName = "node";
  const std::string time = "time";
  const std::string exitStatus = "exit_status";
  const std::string fieldsArray = "fields";
  // task status data structure
  const std::string id = "id";
  const std::string sdate = "sdate";
  // task info data structure
  const std::string taskId = "id";
  const std::string info = "info";
  const std::string modified = "modified";
  // resource usage data structure
  const std::string CPU = "CPU";
  const std::string IOWAIT = "IOWAIT";
  const std::string VRAM = "VRAM";
  const std::string RRAM = "RRAM";
  const std::string DISK = "DISK";
  const std::string PROCESSES = "PROCESSES";
  const std::string THREADS = "THREADS";
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce_json_message_const
} // end namespace drce
} // end namespace HCE

#endif // DRCE_JSON_MESSAGE_CONST_HPP
