/**
 * @file DRCETaskRequestTerminateExecutor.hpp
 *
 * Implementation class DRCETaskRequestTerminateExecutor of a Distributed Remote Command Execution functional object in HCE cluster node.
 *
 * @author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef DRCE_TASK_REQUEST_TERMINATE_EXECUTOR_HPP
#define DRCE_TASK_REQUEST_TERMINATE_EXECUTOR_HPP

#include "DRCEError.hpp"
#include "DRCEMessageConst.hpp"
#include "DRCETaskRequestExecutor.hpp"
#include "DRCECommonTask.hpp"

namespace HCE
{
namespace drce
{
class DRCETaskRequestTerminate;
//-----------------------------------------------------------------------------
class DRCETaskRequestTerminateExecutor : public DRCETaskRequestExecutor
{
public:
  DRCETaskRequestTerminateExecutor(DRCEAsyncTasksQueue& asyncTaskQueue_, DRCENodeOptions& nodeOptions_, CustomMessage& message_, DRCEResourceMonitor& resourceMonitor_);
  virtual ~DRCETaskRequestTerminateExecutor(void) {}

  DRCEResultDataItem execute(DRCETaskRequest* pTaskRequest, DRCEInputJsonMessage& inputJsonMessage);
private:
  void executeDefaultAlgorithm(DRCETaskRequestTerminate& taskRequestTerminate, pid_t pid, DRCEResultDataItem& resultDataItem) throw (Poco::Exception);
  void executeCustomAlgorithm(DRCETaskRequestTerminate& taskRequestTerminate, pid_t pid, DRCEResultDataItem& resultDataItem) throw (Poco::Exception);

///???  void setTaskState(AsyncTasks&& asyncTask, DRCEResultDataItem& resultDataItem, DRCETaskRequest::TaskState taskState);
  bool loadStatusFile(DRCEResultDataItem& resultDataItem);
  void terminateTask(unsigned int taskId, DRCETaskRequestTerminate& taskRequestTerminate, DRCEResultDataItem& resultDataItem) throw (Poco::Exception);
///???  void applyCleanup(unsigned int taskId);

  DRCEResultDataItem makeResultDataItem(DRCEInputJsonMessage& inputJsonMessage, unsigned int exitStatus=0);
///???  void updateResultDataItem(DRCEResultDataItem& resultDataItem);

///???  void prepareCleanup(unsigned int taskId, DRCEInputJsonMessage& inputJsonMessage);

  typedef DRCETaskRequestExecutor inherited;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
} // end namespace drce 
} // end namespace HCE 

#endif // DRCE_TASK_REQUEST_TERMINATE_EXECUTOR_HPP
